import { MidwayConfig } from '@midwayjs/core';
const ip = '127.0.0.1';
const project = 'zkzx';
const mongodb = 'zkzx_v2';
export default {
  // use for cookie sign key, should change to your own and keep security
  keys: '1672292154640_555',
  koa: {
    globalPrefix: `/${project}/v2/api`,
  },
  swagger: {
    swaggerPath: `/dev/${project}/v2/api/doc`,
  },
  mongoose: {
    dataSource: {
      default: {
        uri: `mongodb://${ip}:27017/${mongodb}`,
        options: {
          user: 'admin',
          pass: 'admin',
          authSource: 'admin',
          useNewUrlParser: true,
        },
        entities: ['./entity'],
      },
      achieve: {
        uri: `mongodb://${ip}:27017/zkzx_v2_achieve`,
        options: {
          user: 'admin',
          pass: 'admin',
          authSource: 'admin',
          useNewUrlParser: true,
        },
        entities: ['./entityAchieve'],
      },
    },
  },
  // redis: {
  //   client: {
  //     port: 6379, // Redis port
  //     host: '120.48.146.1', // Redis host
  //     password: '123456',
  //     db: 4,
  //   },
  // },
  axios: {
    clients: {
      file: {
        baseURL: 'http://broadcast.waityou24.cn',
        //表明返回服务器返回的数据类型
        responseType: 'arraybuffer',
        headers: {
          'Content-Type': 'application/json; application/octet-stream',
        },
      },
    },
  },
  export: {
    root_path: 'D:\\temp',
  },
} as MidwayConfig;
