import { Controller, Get, Inject } from '@midwayjs/decorator';
import { Context } from '@midwayjs/koa';
import { ApiResponse, ApiTags } from '@midwayjs/swagger';
const assert = require('assert');
import { JwtService } from '@midwayjs/jwt';
import get = require('lodash/get');
@ApiTags(['解析token'])
@Controller('/token')
export class TokenController {
  @Inject()
  jwtService: JwtService;

  @Inject()
  ctx: Context;

  @Get('/tokenView')
  @ApiResponse({})
  async tokenView() {
    const token = get(this.ctx, 'request.header.token');
    assert(token, '缺少token信息');
    const result: any = await this.jwtService.decode(token);
    return result;
  }
}
