import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'channel' },
})
export class Channel extends BaseModel {
  @prop({ required: false, index: true, zh: '房间号', remark: '2001开始' })
  room_id: string;
  @prop({ required: false, index: true, zh: '用户类型', default: '8' })
  type: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({
    required: false,
    index: true,
    zh: '类别',
    remark: '字典：channel_type',
  })
  channel_type: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '更新时间' })
  create_date: string;
  @prop({ required: false, index: true, zh: '来源' })
  origin: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：channel_status',
    default: '0',
  })
  status: string;
  @prop({
    required: false,
    index: true,
    zh: '角色',
    default: ['64422906b9ded9e96a77c37b'],
  })
  role: Array<any>;
}
