import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'channelVideo' },
})
export class ChannelVideo extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  channel_id: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '开始时间' })
  start_dete: string;
  @prop({ required: false, index: true, zh: '结束时间' })
  end_date: string;
  @prop({ required: false, index: false, zh: '视频文件' })
  video_file: Array<any>;
  @prop({ required: false, index: true, zh: '排序', default: '0' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
