import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'newsColumn' },
})
export class NewsColumn extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  title: string;
  @prop({
    required: false,
    index: true,
    zh: '位置',
    remark: '字典：news_place',
  })
  place: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
