import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'newsMess' },
})
export class NewsMess extends BaseModel {
  @prop({ required: false, index: true, zh: '所属栏目' })
  column_id: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({
    required: false,
    index: true,
    zh: '信息类型',
    remark: '字典：news_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '发布时间' })
  create_date: string;
  @prop({ required: false, index: false, zh: '信息来源' })
  origin: string;
  @prop({ required: false, index: false, zh: '信息简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '图片文件' })
  image_file: Array<any>;
  @prop({ required: false, index: false, zh: '视频文件' })
  video_file: Array<any>;
  @prop({ required: false, index: false, zh: '附件文件' })
  annex_file: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否收费',
    remark: '字典表：common_isno',
  })
  is_money: string;
  @prop({ required: false, index: false, zh: '收费图片' })
  money_file: Array<any>;
  @prop({ required: false, index: true, zh: '关联展会' })
  expo_id: string;
  @prop({ required: false, index: false, zh: '信息内容' })
  content: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
