import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'personChat' },
})
export class PersonChat extends BaseModel {
  @prop({ required: false, index: true, zh: '房间id' })
  room_id: string;
  @prop({ required: false, index: true, zh: '发送人id' })
  sender_id: string;
  @prop({ required: false, index: true, zh: '发送人姓名' })
  sender_name: string;
  @prop({ required: false, index: true, zh: '接收人id' })
  receiver_id: string;
  @prop({ required: false, index: true, zh: '接收人姓名' })
  receiver_name: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: true, zh: '发送时间' })
  send_time: string;
  @prop({
    required: false,
    index: true,
    zh: '是否已读',
    remark: '字典：common_isno',
    default: '1',
  })
  is_read: string;
}
