import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'product' },
})
export class Product extends BaseModel {
  @prop({ required: false, index: true, zh: '所属用户' })
  user_id: string;
  @prop({
    required: false,
    index: true,
    zh: '类型',
    remark: '字典：product_type.0：科技需求，1：技术成果，2：商务服务',
  })
  type: string;
  @prop({ required: false, index: true, zh: '企业名称' })
  company: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: 'qq&微信' })
  qqwx: string;
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({
    required: false,
    index: true,
    zh: '需求紧急程度/需求程度',
    remark: '字典：product_demand',
  })
  demand: string;
  @prop({
    required: false,
    index: true,
    zh: '所属领域',
    remark: '字典：product_field',
  })
  field: string;
  @prop({ required: false, index: true, zh: '投资预算' })
  budget: string;
  @prop({
    required: false,
    index: true,
    zh: '合作方式',
    remark: '字典：product_cooperation',
  })
  cooperation: string;
  @prop({ required: false, index: false, zh: '技术说明' })
  requirementdesc: string;
  @prop({ required: false, index: false, zh: '预期目标/商业预期' })
  expect: string;
  @prop({ required: false, index: false, zh: '需求现状' })
  present: string;
  @prop({ required: false, index: false, zh: '合作条件及要求' })
  condition: string;
  @prop({ required: false, index: false, zh: '产品图片(6)' })
  file: Array<any>;
  @prop({
    required: false,
    index: false,
    zh: '成果状态',
    remark: '字典：product_achievestatus',
  })
  achievestatus: string;
  @prop({ required: false, index: false, zh: '成果权属' })
  achieveown: string;
  @prop({
    required: false,
    index: false,
    zh: '成果来源',
    remark: '字典：product_achievesource',
  })
  achievesource: string;
  @prop({ required: false, index: false, zh: '意向价格' })
  intentionprice: string;
  @prop({ required: false, index: false, zh: '专利信息' })
  patent: Array<any>;
  @prop({ required: false, index: false, zh: '项目路演' })
  roadshow: Array<any>;
  @prop({ required: false, index: false, zh: '成果简介' })
  achievebrief: string;
  @prop({ required: false, index: false, zh: '技术特点' })
  features: string;
  @prop({ required: false, index: false, zh: '技术团队' })
  team: string;
  @prop({
    required: false,
    index: false,
    zh: '信息属性',
    remark: '字典：product_messattribute',
  })
  messattribute: string;
  @prop({ required: false, index: false, zh: '信息描述' })
  informationdesc: string;
  @prop({ required: false, index: false, zh: '核心要素' })
  coreelements: string;
  @prop({ required: false, index: false, zh: '价格信息' })
  priceinfo: string;
  @prop({
    required: false,
    index: false,
    zh: '状态',
    remark: '字典：product_status',
    default: '0',
  })
  status: string;
}
