import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'projectInfo' },
})
export class ProjectInfo extends BaseModel {
  @prop({ required: false, index: true, zh: '年度' })
  year: string;
  @prop({ required: false, index: true, zh: '关联通知' })
  notice_id: string;
  @prop({ required: false, index: true, zh: '用户id' })
  user_id: string;
  @prop({ required: false, index: true, zh: '项目名称' })
  name: string;
  @prop({ required: false, index: true, zh: '项目负责人' })
  pro_contact: string;
  @prop({ required: false, index: true, zh: '项目负责人手机号' })
  pro_phone: string;
  @prop({ required: false, index: false, zh: '领域分类' })
  field: string;
  @prop({ required: false, index: false, zh: '市场预估' })
  scale: string;
  @prop({
    required: false,
    index: false,
    zh: '技术阶段',
    remark: '字典表：project_collect_stage',
  })
  techol_stage: string;
  @prop({
    required: false,
    index: false,
    zh: '技术水平',
    remark: '字典表：project_collect_level',
  })
  techol_level: string;
  @prop({
    required: false,
    index: true,
    zh: '建议单位名称',
    remark: '字典表：project_collect_field',
  })
  proposal_company: string;
  @prop({ required: false, index: true, zh: '建议单位联系人' })
  proposal_contact: string;
  @prop({ required: false, index: true, zh: '建议单位手机号' })
  proposal_phone: string;
  @prop({ required: false, index: true, zh: '合作单位名称' })
  coopera_company: string;
  @prop({ required: false, index: true, zh: '合作单位联系人' })
  coopera_contact: string;
  @prop({ required: false, index: true, zh: '合作单位手机号' })
  coopera_phone: string;
  @prop({ required: false, index: false, zh: '项目背景' })
  project_back: string;
  @prop({ required: false, index: false, zh: '立项意义' })
  sign: string;
  @prop({ required: false, index: false, zh: '前期基础' })
  work_basics: string;
  @prop({ required: false, index: false, zh: '研究内容' })
  content: string;
  @prop({ required: false, index: false, zh: '技术路线' })
  route: string;
  @prop({ required: false, index: false, zh: '核心指标' })
  quota: string;
  @prop({ required: false, index: false, zh: '经济效益' })
  influence: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典表：project_collect_status',
    default: '0',
  })
  status: string;
}
