import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'projectNotice' },
})
export class ProjectNotice extends BaseModel {
  @prop({ required: false, index: true, zh: '年度' })
  year: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '来源' })
  origin: string;
  @prop({ required: false, index: true, zh: '发布时间' })
  create_date: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '图片文件' })
  img_url: Array<any>;
  @prop({ required: false, index: false, zh: '附件文件' })
  file_url: Array<any>;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表：common_use',
    default: '0',
  })
  is_use: string;
}
