import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'subscribeOrder' },
})
export class SubscribeOrder extends BaseModel {
  @prop({
    required: false,
    index: true,
    zh: '服务类型',
    remark: '字典：subscribe_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '机构' })
  organ_id: string;
  @prop({ required: false, index: true, zh: '服务名称' })
  project: object;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: '服务时间' })
  service_date: string;
  @prop({ required: false, index: false, zh: '预约备注' })
  remerk: string;
  @prop({
    required: false,
    index: true,
    zh: '是否开发票',
    remark: '字典：common_use',
  })
  is_money: string;
  @prop({ required: false, index: true, zh: '单位名称' })
  company: string;
  @prop({ required: false, index: true, zh: '机构代码' })
  company_code: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：subscribe_status',
    default: '0',
  })
  status: string;
}
