import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'subscribeOrgan' },
})
export class SubscribeOrgan extends BaseModel {
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '联系人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '联系地址' })
  address: string;
  @prop({
    required: false,
    index: true,
    zh: '所属',
    remark: '字典：subscribe_belong  0:中科，1：吉林科',
  })
  belong: string;
  @prop({ required: false, index: false, zh: '资质' })
  natural: string;
  @prop({ required: false, index: false, zh: '成果' })
  achieve: string;
  @prop({ required: false, index: false, zh: '条件' })
  condition: string;
  @prop({ required: false, index: false, zh: '团队' })
  team: string;
  @prop({ required: false, index: false, zh: '图片' })
  image_file: Array<any>;
  @prop({ required: false, index: false, zh: '服务项目' })
  project: Array<any>;
  @prop({ required: false, index: false, zh: '设备共享' })
  equipment: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
