import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'menus' },
})
export class Menus extends BaseModel {
  @prop({ required: false, index: true, zh: '菜单名称' })
  name: string;
  @prop({ required: false, index: true, zh: '模块id' })
  module_id: string;
  @prop({ required: false, index: true, zh: '父级菜单' })
  parent_id: string;
  @prop({ required: false, index: true, zh: '路由地址' })
  path: string;
  @prop({ required: false, index: true, zh: '组件地址' })
  component: string;
  @prop({
    required: false,
    index: true,
    zh: '菜单类型',
    remark: '字典：menus_type',
  })
  type: string;
  @prop({ required: false, index: true, zh: '图标' })
  icon: string;
  @prop({ required: false, index: false, zh: '设置' })
  config: object;
  @prop({ required: false, index: true, zh: '显示顺序' })
  sort: number;
  @prop({ required: false, index: false, zh: '备注' })
  remark: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典表：common_use',
    default: '0',
  })
  is_use: string;
}
