import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dockChat' },
})
export class DockChat extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  dock_id: string;
  @prop({ required: false, index: true, zh: '发送人id' })
  sender_id: string;
  @prop({ required: false, index: true, zh: '发送人' })
  sender_name: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: true, zh: '发送时间' })
  send_time: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
