import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dockExpert' },
})
export class DockExpert extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  dock_id: string;
  @prop({ required: false, index: true, zh: '关联专家id' })
  expert_id: string;
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: true, zh: '头像' })
  icon: Array<any>;
  @prop({ required: false, index: true, zh: '最高学历' })
  education: string;
  @prop({ required: false, index: true, zh: '所在院校' })
  school: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
