import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dockImgtxt' },
})
export class DockImgtxt extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  dock_id: string;
  @prop({ required: false, index: true, zh: '发送人' })
  user_id: string;
  @prop({ required: false, index: true, zh: '内容' })
  content: string;
  @prop({ required: false, index: false, zh: '图片文件' })
  img_file: Array<any>;
  @prop({ required: false, index: false, zh: '视频文件' })
  video_file: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典表：common_use',
    default: '0',
  })
  is_use: string;
  @prop({ required: false, index: false, zh: '发送时间' })
  create_time: string;
}
