import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dockTrans' },
})
export class DockTrans extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  dock_id: string;
  @prop({ required: false, index: true, zh: '产品id' })
  product_id: string;
  @prop({ required: false, index: true, zh: '产品名称' })
  product_name: string;
  @prop({ required: false, index: true, zh: '供给者id' })
  s_id: string;
  @prop({ required: false, index: true, zh: '供给者姓名' })
  s_name: string;
  @prop({ required: false, index: true, zh: '供给者手机号' })
  s_phone: string;
  @prop({ required: false, index: true, zh: '需求者id' })
  d_id: string;
  @prop({ required: false, index: true, zh: '需求者姓名' })
  d_name: string;
  @prop({ required: false, index: true, zh: '需求者手机号' })
  d_phone: string;
  @prop({ required: false, index: false, zh: '合同备份' })
  contract: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：dock_trans_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: true, zh: '创建时间' })
  create_time: string;
}
