import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dockUser' },
})
export class DockUser extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  dock_id: string;
  @prop({ required: false, index: true, zh: '申请人id' })
  user_id: string;
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: true, zh: '手机' })
  phone: string;
  @prop({ required: false, index: true, zh: '申请时间' })
  apply_date: string;
  @prop({ required: false, index: false, zh: '参展项目' })
  productList: Array<any>;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：common_status',
    default: '0',
  })
  status: string;
}
