import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'dockXmly' },
})
export class DockXmly extends BaseModel {
  @prop({ required: false, index: true, zh: '关联展会id' })
  dock_id: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '发布时间' })
  create_date: string;
  @prop({ required: false, index: true, zh: '信息来源' })
  origin: string;
  @prop({ required: false, index: false, zh: '信息简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '图片文件' })
  image_file: Array<any>;
  @prop({ required: false, index: false, zh: '附件文件' })
  annex_file: Array<any>;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({
    required: false,
    index: true,
    zh: '是否使用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
