import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'train' },
})
export class Train extends BaseModel {
  @prop({ required: false, index: true, zh: '房间号', remark: '3001开始' })
  room_id: string;
  @prop({ required: false, index: true, zh: '用户类型', default: '9' })
  type: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: true, zh: '开始时间' })
  start_time: string;
  @prop({ required: false, index: true, zh: '结束时间' })
  end_time: string;
  @prop({ required: false, index: true, zh: '省份' })
  province: string;
  @prop({ required: false, index: true, zh: '市区' })
  city: string;
  @prop({ required: false, index: true, zh: '负责人' })
  contact: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '主办方' })
  sponsor: string;
  @prop({ required: false, index: false, zh: '承办方' })
  organizer: string;
  @prop({ required: false, index: false, zh: '信息简介' })
  brief: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：train_status',
    default: '0',
  })
  status: string;
  @prop({
    required: false,
    index: true,
    zh: '角色',
    default: ['64422947b9ded9e96a77ca98'],
  })
  role: Array<any>;
}
