import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'trainChat' },
})
export class TrainChat extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  train_id: string;
  @prop({ required: false, index: true, zh: '发送人id' })
  sender_id: string;
  @prop({ required: false, index: true, zh: '发送人姓名' })
  sender_name: string;
  @prop({ required: false, index: false, zh: '内容' })
  content: string;
  @prop({ required: false, index: true, zh: '时间' })
  send_time: string;
  @prop({
    required: false,
    index: false,
    zh: '是否使用',
    remark: '字典表：common_use',
    default: '0',
  })
  is_use: string;
}
