import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'trainUser' },
})
export class TrainUser extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  train_id: string;
  @prop({ required: false, index: true, zh: '用户类型', default: '10' })
  type: string;
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：common_status',
  })
  status: string;
}
