import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'trainVideo' },
})
export class TrainVideo extends BaseModel {
  @prop({ required: false, index: true, zh: '展会id' })
  train_id: string;
  @prop({ required: false, index: true, zh: '标题' })
  title: string;
  @prop({ required: false, index: false, zh: '简介' })
  brief: string;
  @prop({ required: false, index: false, zh: '视频文件' })
  video_file: Array<any>;
  @prop({ required: false, index: true, zh: '排序', default: '0' })
  sort: number;
  @prop({
    required: false,
    index: true,
    zh: '是否启用',
    remark: '字典：common_use',
    default: '0',
  })
  is_use: string;
}
