import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'admin' },
})
export class Admin extends BaseModel {
  @prop({ required: false, index: true, zh: '所属上级' })
  pid: string;
  @prop({
    required: false,
    index: true,
    zh: '用户类型',
    remark: '0：超级管理员，1：管理员，2：机构用户，3：业务用户',
  })
  type: string;
  @prop({
    required: false,
    index: true,
    zh: '邀请码',
    remark: '字典表：account_code',
  })
  code: string;
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '名称' })
  name: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '机构名称' })
  dept_name: string;
  @prop({ required: false, index: true, zh: '角色' })
  role: Array<any>;
}
