import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'company' },
})
export class Company extends BaseModel {
  @prop({ required: false, index: true, zh: '用户类型', default: '5' })
  type: string;
  @prop({ required: false, index: true, zh: '邀请码' })
  code: string;
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: true, zh: '联系地址' })
  address: string;
  @prop({ required: false, index: true, zh: '办公电话' })
  work_phone: string;
  @prop({ required: false, index: true, zh: '所属行业' })
  industry: string;
  @prop({
    required: false,
    index: true,
    zh: '所属辖区',
    remark: '字典：jl_area',
  })
  area: string;
  @prop({ required: false, index: true, zh: '机构代码' })
  institution_code: string;
  @prop({ required: false, index: false, zh: '注册类型' })
  companytype: string;
  @prop({ required: false, index: false, zh: '注册时间' })
  companydate: string;
  @prop({ required: false, index: false, zh: '注册资金' })
  companycapital: string;
  @prop({ required: false, index: false, zh: '企业法人' })
  companyperson: string;
  @prop({ required: false, index: false, zh: '上年度企业总收入' })
  sndqyzsr: string;
  @prop({ required: false, index: false, zh: '上年度研发费用' })
  sndyffy: string;
  @prop({ required: false, index: false, zh: '企业总人数' })
  companytotal: string;
  @prop({ required: false, index: false, zh: '专&兼职研发人数' })
  zjzyfrs: string;
  @prop({ required: false, index: false, zh: '企业简介' })
  companybrief: string;
  @prop({ required: false, index: false, zh: '主要产品' })
  mainproduct: string;
  @prop({ required: false, index: false, zh: '企业资质&荣誉' })
  qualifications: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：comon_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: true, zh: '角色' })
  role: Array<any>;
}
