import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'expert' },
})
export class Expert extends BaseModel {
  @prop({ required: false, index: true, zh: '账号类型', default: '6' })
  type: string;
  @prop({ required: false, index: true, zh: '邀请码' })
  code: string;
  @prop({ required: false, index: true, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: true, zh: '姓名' })
  name: string;
  @prop({ required: false, index: true, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: true, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '联系地址' })
  address: string;
  @prop({ required: false, index: false, zh: '办公电话' })
  work_phone: string;
  @prop({ required: false, index: false, zh: '所属行业' })
  industry: string;
  @prop({
    required: false,
    index: false,
    zh: '所属辖区',
    remark: '字典：jl_area',
  })
  area: string;
  @prop({ required: false, index: true, zh: '身份证号' })
  card: string;
  @prop({ required: false, index: false, zh: '出生日期' })
  birth: string;
  @prop({ required: false, index: false, zh: 'qq&&微信' })
  qqwx: string;
  @prop({ required: false, index: false, zh: '所在院校' })
  school: string;
  @prop({ required: false, index: false, zh: '最高学历' })
  education: string;
  @prop({ required: false, index: false, zh: '所学专业' })
  major: string;
  @prop({ required: false, index: false, zh: '单位名称' })
  company: string;
  @prop({ required: false, index: false, zh: '职务职称' })
  zwzc: string;
  @prop({ required: false, index: false, zh: '头像图片' })
  icon: Array<any>;
  @prop({ required: false, index: false, zh: '擅长领域' })
  expertise: string;
  @prop({ required: false, index: false, zh: '工作经历' })
  workexperience: string;
  @prop({ required: false, index: false, zh: '科研综述' })
  scientific: string;
  @prop({ required: false, index: false, zh: '承担项目' })
  undertakingproject: string;
  @prop({ required: false, index: false, zh: '科技奖励' })
  scienceaward: string;
  @prop({ required: false, index: false, zh: '社会任职' })
  social: string;
  @prop({
    required: false,
    index: true,
    zh: '状态',
    remark: '字典：common_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: true, zh: '个人用户id' })
  personal_id: string;
  @prop({ required: false, index: true, zh: '角色' })
  role: Array<any>;
}
