import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
import isString = require('lodash/isString');
@modelOptions({
  schemaOptions: { collection: 'personal' },
})
export class Personal extends BaseModel {
  @prop({ required: false, index: false, zh: '用户类型', default: '4' })
  type: string;
  @prop({ required: false, index: false, zh: '邀请码' })
  code: string;
  @prop({ required: false, index: false, zh: '账号' })
  account: string;
  @prop({
    required: false,
    index: false,
    zh: '密码',
    select: false,
    set: (val: string | object) => {
      if (isString(val)) {
        return { secret: val };
      }
      return val;
    },
  })
  password: {
    secret: string;
  };
  @prop({ required: false, index: false, zh: '姓名' })
  name: string;
  @prop({ required: false, index: false, zh: '手机号' })
  phone: string;
  @prop({ required: false, index: false, zh: '电子邮箱' })
  email: string;
  @prop({ required: false, index: false, zh: '联系地址' })
  address: string;
  @prop({ required: false, index: false, zh: '办公电话' })
  work_phone: string;
  @prop({ required: false, index: false, zh: '所属行业' })
  industry: string;
  @prop({
    required: false,
    index: false,
    zh: '所属辖区',
    remark: '字典表：jl_area',
  })
  area: string;
  @prop({ required: false, index: false, zh: '身份证号' })
  card: string;
  @prop({ required: false, index: false, zh: '职务职称' })
  zwzc: string;
  @prop({ required: false, index: false, zh: '所在院系' })
  school: string;
  @prop({ required: false, index: false, zh: '所学专业' })
  major: string;
  @prop({
    required: false,
    index: false,
    zh: '状态',
    remark: '字典表：common_status',
    default: '0',
  })
  status: string;
  @prop({ required: false, index: true, zh: '角色' })
  role: Array<any>;
}
