import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_newsColumn {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'title': string = undefined;
  @ApiProperty({ description: '位置' })
  'place': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_newsColumn extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['title', 'place', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'title': string = undefined;
  @ApiProperty({ description: '位置' })
  'place': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_newsColumn extends FVO_newsColumn {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_newsColumn {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '位置' })
  @Rule(RuleType['string']().empty(''))
  'place': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_newsColumn extends FVO_newsColumn {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_newsColumn extends CDTO_newsColumn {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_newsColumn extends FVO_newsColumn {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
