import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_newsMess {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '所属栏目' })
  'column_id': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '信息类型' })
  'type': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'create_date': string = undefined;
  @ApiProperty({ description: '信息来源' })
  'origin': string = undefined;
  @ApiProperty({ description: '信息简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '图片文件' })
  'image_file': Array<any> = undefined;
  @ApiProperty({ description: '视频文件' })
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '附件文件' })
  'annex_file': Array<any> = undefined;
  @ApiProperty({ description: '是否收费' })
  'is_money': string = undefined;
  @ApiProperty({ description: '收费图片' })
  'money_file': Array<any> = undefined;
  @ApiProperty({ description: '关联展会' })
  'expo_id': string = undefined;
  @ApiProperty({ description: '信息内容' })
  'content': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_newsMess extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'column_id',
      'title',
      'type',
      'create_date',
      'is_money',
      'expo_id',
      'is_use',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '所属栏目' })
  'column_id': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '信息类型' })
  'type': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'create_date': string = undefined;
  @ApiProperty({ description: '是否收费' })
  'is_money': string = undefined;
  @ApiProperty({ description: '关联展会' })
  'expo_id': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_newsMess extends FVO_newsMess {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_newsMess {
  @ApiProperty({ description: '所属栏目' })
  @Rule(RuleType['string']().empty(''))
  'column_id': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '信息类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '发布时间' })
  @Rule(RuleType['string']().empty(''))
  'create_date': string = undefined;
  @ApiProperty({ description: '信息来源' })
  @Rule(RuleType['string']().empty(''))
  'origin': string = undefined;
  @ApiProperty({ description: '信息简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '图片文件' })
  @Rule(RuleType['array']().empty(''))
  'image_file': Array<any> = undefined;
  @ApiProperty({ description: '视频文件' })
  @Rule(RuleType['array']().empty(''))
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '附件文件' })
  @Rule(RuleType['array']().empty(''))
  'annex_file': Array<any> = undefined;
  @ApiProperty({ description: '是否收费' })
  @Rule(RuleType['string']().empty(''))
  'is_money': string = undefined;
  @ApiProperty({ description: '收费图片' })
  @Rule(RuleType['array']().empty(''))
  'money_file': Array<any> = undefined;
  @ApiProperty({ description: '关联展会' })
  @Rule(RuleType['string']().empty(''))
  'expo_id': string = undefined;
  @ApiProperty({ description: '信息内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_newsMess extends FVO_newsMess {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_newsMess extends CDTO_newsMess {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_newsMess extends FVO_newsMess {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
