import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_personChat {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '房间id' })
  'room_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人姓名' })
  'sender_name': string = undefined;
  @ApiProperty({ description: '接收人id' })
  'receiver_id': string = undefined;
  @ApiProperty({ description: '接收人姓名' })
  'receiver_name': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_time': string = undefined;
  @ApiProperty({ description: '是否已读' })
  'is_read': string = undefined;
}

export class QDTO_personChat extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'room_id',
      'sender_id',
      'sender_name',
      'receiver_id',
      'receiver_name',
      'send_time',
      'is_read',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '房间id' })
  'room_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人姓名' })
  'sender_name': string = undefined;
  @ApiProperty({ description: '接收人id' })
  'receiver_id': string = undefined;
  @ApiProperty({ description: '接收人姓名' })
  'receiver_name': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_time': string = undefined;
  @ApiProperty({ description: '是否已读' })
  'is_read': string = undefined;
}

export class QVO_personChat extends FVO_personChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_personChat {
  @ApiProperty({ description: '房间id' })
  @Rule(RuleType['string']().empty(''))
  'room_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  @Rule(RuleType['string']().empty(''))
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人姓名' })
  @Rule(RuleType['string']().empty(''))
  'sender_name': string = undefined;
  @ApiProperty({ description: '接收人id' })
  @Rule(RuleType['string']().empty(''))
  'receiver_id': string = undefined;
  @ApiProperty({ description: '接收人姓名' })
  @Rule(RuleType['string']().empty(''))
  'receiver_name': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '发送时间' })
  @Rule(RuleType['string']().empty(''))
  'send_time': string = undefined;
  @ApiProperty({ description: '是否已读' })
  @Rule(RuleType['string']().empty(''))
  'is_read': string = undefined;
}

export class CVO_personChat extends FVO_personChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_personChat extends CDTO_personChat {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_personChat extends FVO_personChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
