import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_personRoom {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '产品id' })
  'product_id': string = undefined;
  @ApiProperty({ description: '产品名称' })
  'product_name': string = undefined;
  @ApiProperty({ description: '第一个人id' })
  'p1_id': string = undefined;
  @ApiProperty({ description: '第一个人姓名' })
  'p1_name': string = undefined;
  @ApiProperty({ description: '第二个人id' })
  'p2_id': string = undefined;
  @ApiProperty({ description: '第二个人姓名' })
  'p2_name': string = undefined;
  @ApiProperty({ description: '最后发言时间' })
  'last_time': string = undefined;
}

export class QDTO_personRoom extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'product_id',
      'product_name',
      'p1_id',
      'p1_name',
      'p2_id',
      'p2_name',
      'last_time',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '产品id' })
  'product_id': string = undefined;
  @ApiProperty({ description: '产品名称' })
  'product_name': string = undefined;
  @ApiProperty({ description: '第一个人id' })
  'p1_id': string = undefined;
  @ApiProperty({ description: '第一个人姓名' })
  'p1_name': string = undefined;
  @ApiProperty({ description: '第二个人id' })
  'p2_id': string = undefined;
  @ApiProperty({ description: '第二个人姓名' })
  'p2_name': string = undefined;
  @ApiProperty({ description: '最后发言时间' })
  'last_time': string = undefined;
}

export class QVO_personRoom extends FVO_personRoom {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_personRoom {
  @ApiProperty({ description: '产品id' })
  @Rule(RuleType['string']().empty(''))
  'product_id': string = undefined;
  @ApiProperty({ description: '产品名称' })
  @Rule(RuleType['string']().empty(''))
  'product_name': string = undefined;
  @ApiProperty({ description: '第一个人id' })
  @Rule(RuleType['string']().empty(''))
  'p1_id': string = undefined;
  @ApiProperty({ description: '第一个人姓名' })
  @Rule(RuleType['string']().empty(''))
  'p1_name': string = undefined;
  @ApiProperty({ description: '第二个人id' })
  @Rule(RuleType['string']().empty(''))
  'p2_id': string = undefined;
  @ApiProperty({ description: '第二个人姓名' })
  @Rule(RuleType['string']().empty(''))
  'p2_name': string = undefined;
  @ApiProperty({ description: '最后发言时间' })
  @Rule(RuleType['string']().empty(''))
  'last_time': string = undefined;
}

export class CVO_personRoom extends FVO_personRoom {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_personRoom extends CDTO_personRoom {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_personRoom extends FVO_personRoom {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
