import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_product {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '所属用户' })
  'user_id': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '企业名称' })
  'company': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: 'qq&微信' })
  'qqwx': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '需求紧急程度/需求程度' })
  'demand': string = undefined;
  @ApiProperty({ description: '所属领域' })
  'field': string = undefined;
  @ApiProperty({ description: '投资预算' })
  'budget': string = undefined;
  @ApiProperty({ description: '合作方式' })
  'cooperation': string = undefined;
  @ApiProperty({ description: '技术说明' })
  'requirementdesc': string = undefined;
  @ApiProperty({ description: '预期目标/商业预期' })
  'expect': string = undefined;
  @ApiProperty({ description: '需求现状' })
  'present': string = undefined;
  @ApiProperty({ description: '合作条件及要求' })
  'condition': string = undefined;
  @ApiProperty({ description: '产品图片(6)' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '成果状态' })
  'achievestatus': string = undefined;
  @ApiProperty({ description: '成果权属' })
  'achieveown': string = undefined;
  @ApiProperty({ description: '成果来源' })
  'achievesource': string = undefined;
  @ApiProperty({ description: '意向价格' })
  'intentionprice': string = undefined;
  @ApiProperty({ description: '专利信息' })
  'patent': Array<any> = undefined;
  @ApiProperty({ description: '项目路演' })
  'roadshow': Array<any> = undefined;
  @ApiProperty({ description: '成果简介' })
  'achievebrief': string = undefined;
  @ApiProperty({ description: '技术特点' })
  'features': string = undefined;
  @ApiProperty({ description: '技术团队' })
  'team': string = undefined;
  @ApiProperty({ description: '信息属性' })
  'messattribute': string = undefined;
  @ApiProperty({ description: '信息描述' })
  'informationdesc': string = undefined;
  @ApiProperty({ description: '核心要素' })
  'coreelements': string = undefined;
  @ApiProperty({ description: '价格信息' })
  'priceinfo': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_product extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'user_id',
      'type',
      'company',
      'contact',
      'phone',
      'email',
      'qqwx',
      'name',
      'demand',
      'field',
      'budget',
      'cooperation',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '所属用户' })
  'user_id': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '企业名称' })
  'company': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: 'qq&微信' })
  'qqwx': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '需求紧急程度/需求程度' })
  'demand': string = undefined;
  @ApiProperty({ description: '所属领域' })
  'field': string = undefined;
  @ApiProperty({ description: '投资预算' })
  'budget': string = undefined;
  @ApiProperty({ description: '合作方式' })
  'cooperation': string = undefined;
}

export class QVO_product extends FVO_product {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_product {
  @ApiProperty({ description: '所属用户' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '企业名称' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: 'qq&微信' })
  @Rule(RuleType['string']().empty(''))
  'qqwx': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '需求紧急程度/需求程度' })
  @Rule(RuleType['string']().empty(''))
  'demand': string = undefined;
  @ApiProperty({ description: '所属领域' })
  @Rule(RuleType['string']().empty(''))
  'field': string = undefined;
  @ApiProperty({ description: '投资预算' })
  @Rule(RuleType['string']().empty(''))
  'budget': string = undefined;
  @ApiProperty({ description: '合作方式' })
  @Rule(RuleType['string']().empty(''))
  'cooperation': string = undefined;
  @ApiProperty({ description: '技术说明' })
  @Rule(RuleType['string']().empty(''))
  'requirementdesc': string = undefined;
  @ApiProperty({ description: '预期目标/商业预期' })
  @Rule(RuleType['string']().empty(''))
  'expect': string = undefined;
  @ApiProperty({ description: '需求现状' })
  @Rule(RuleType['string']().empty(''))
  'present': string = undefined;
  @ApiProperty({ description: '合作条件及要求' })
  @Rule(RuleType['string']().empty(''))
  'condition': string = undefined;
  @ApiProperty({ description: '产品图片(6)' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '成果状态' })
  @Rule(RuleType['string']().empty(''))
  'achievestatus': string = undefined;
  @ApiProperty({ description: '成果权属' })
  @Rule(RuleType['string']().empty(''))
  'achieveown': string = undefined;
  @ApiProperty({ description: '成果来源' })
  @Rule(RuleType['string']().empty(''))
  'achievesource': string = undefined;
  @ApiProperty({ description: '意向价格' })
  @Rule(RuleType['string']().empty(''))
  'intentionprice': string = undefined;
  @ApiProperty({ description: '专利信息' })
  @Rule(RuleType['array']().empty(''))
  'patent': Array<any> = undefined;
  @ApiProperty({ description: '项目路演' })
  @Rule(RuleType['array']().empty(''))
  'roadshow': Array<any> = undefined;
  @ApiProperty({ description: '成果简介' })
  @Rule(RuleType['string']().empty(''))
  'achievebrief': string = undefined;
  @ApiProperty({ description: '技术特点' })
  @Rule(RuleType['string']().empty(''))
  'features': string = undefined;
  @ApiProperty({ description: '技术团队' })
  @Rule(RuleType['string']().empty(''))
  'team': string = undefined;
  @ApiProperty({ description: '信息属性' })
  @Rule(RuleType['string']().empty(''))
  'messattribute': string = undefined;
  @ApiProperty({ description: '信息描述' })
  @Rule(RuleType['string']().empty(''))
  'informationdesc': string = undefined;
  @ApiProperty({ description: '核心要素' })
  @Rule(RuleType['string']().empty(''))
  'coreelements': string = undefined;
  @ApiProperty({ description: '价格信息' })
  @Rule(RuleType['string']().empty(''))
  'priceinfo': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_product extends FVO_product {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_product extends CDTO_product {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_product extends FVO_product {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
