import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_projectInfo {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '年度' })
  'year': string = undefined;
  @ApiProperty({ description: '关联通知' })
  'notice_id': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '项目负责人' })
  'pro_contact': string = undefined;
  @ApiProperty({ description: '项目负责人手机号' })
  'pro_phone': string = undefined;
  @ApiProperty({ description: '领域分类' })
  'field': string = undefined;
  @ApiProperty({ description: '市场预估' })
  'scale': string = undefined;
  @ApiProperty({ description: '技术阶段' })
  'techol_stage': string = undefined;
  @ApiProperty({ description: '技术水平' })
  'techol_level': string = undefined;
  @ApiProperty({ description: '建议单位名称' })
  'proposal_company': string = undefined;
  @ApiProperty({ description: '建议单位联系人' })
  'proposal_contact': string = undefined;
  @ApiProperty({ description: '建议单位手机号' })
  'proposal_phone': string = undefined;
  @ApiProperty({ description: '合作单位名称' })
  'coopera_company': string = undefined;
  @ApiProperty({ description: '合作单位联系人' })
  'coopera_contact': string = undefined;
  @ApiProperty({ description: '合作单位手机号' })
  'coopera_phone': string = undefined;
  @ApiProperty({ description: '项目背景' })
  'project_back': string = undefined;
  @ApiProperty({ description: '立项意义' })
  'sign': string = undefined;
  @ApiProperty({ description: '前期基础' })
  'work_basics': string = undefined;
  @ApiProperty({ description: '研究内容' })
  'content': string = undefined;
  @ApiProperty({ description: '技术路线' })
  'route': string = undefined;
  @ApiProperty({ description: '核心指标' })
  'quota': string = undefined;
  @ApiProperty({ description: '经济效益' })
  'influence': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_projectInfo extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'year',
      'notice_id',
      'user_id',
      'name',
      'pro_contact',
      'pro_phone',
      'proposal_company',
      'proposal_contact',
      'proposal_phone',
      'coopera_company',
      'coopera_contact',
      'coopera_phone',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '年度' })
  'year': string = undefined;
  @ApiProperty({ description: '关联通知' })
  'notice_id': string = undefined;
  @ApiProperty({ description: '用户id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '项目名称' })
  'name': string = undefined;
  @ApiProperty({ description: '项目负责人' })
  'pro_contact': string = undefined;
  @ApiProperty({ description: '项目负责人手机号' })
  'pro_phone': string = undefined;
  @ApiProperty({ description: '建议单位名称' })
  'proposal_company': string = undefined;
  @ApiProperty({ description: '建议单位联系人' })
  'proposal_contact': string = undefined;
  @ApiProperty({ description: '建议单位手机号' })
  'proposal_phone': string = undefined;
  @ApiProperty({ description: '合作单位名称' })
  'coopera_company': string = undefined;
  @ApiProperty({ description: '合作单位联系人' })
  'coopera_contact': string = undefined;
  @ApiProperty({ description: '合作单位手机号' })
  'coopera_phone': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_projectInfo extends FVO_projectInfo {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_projectInfo {
  @ApiProperty({ description: '年度' })
  @Rule(RuleType['string']().empty(''))
  'year': string = undefined;
  @ApiProperty({ description: '关联通知' })
  @Rule(RuleType['string']().empty(''))
  'notice_id': string = undefined;
  @ApiProperty({ description: '用户id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '项目名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '项目负责人' })
  @Rule(RuleType['string']().empty(''))
  'pro_contact': string = undefined;
  @ApiProperty({ description: '项目负责人手机号' })
  @Rule(RuleType['string']().empty(''))
  'pro_phone': string = undefined;
  @ApiProperty({ description: '领域分类' })
  @Rule(RuleType['string']().empty(''))
  'field': string = undefined;
  @ApiProperty({ description: '市场预估' })
  @Rule(RuleType['string']().empty(''))
  'scale': string = undefined;
  @ApiProperty({ description: '技术阶段' })
  @Rule(RuleType['string']().empty(''))
  'techol_stage': string = undefined;
  @ApiProperty({ description: '技术水平' })
  @Rule(RuleType['string']().empty(''))
  'techol_level': string = undefined;
  @ApiProperty({ description: '建议单位名称' })
  @Rule(RuleType['string']().empty(''))
  'proposal_company': string = undefined;
  @ApiProperty({ description: '建议单位联系人' })
  @Rule(RuleType['string']().empty(''))
  'proposal_contact': string = undefined;
  @ApiProperty({ description: '建议单位手机号' })
  @Rule(RuleType['string']().empty(''))
  'proposal_phone': string = undefined;
  @ApiProperty({ description: '合作单位名称' })
  @Rule(RuleType['string']().empty(''))
  'coopera_company': string = undefined;
  @ApiProperty({ description: '合作单位联系人' })
  @Rule(RuleType['string']().empty(''))
  'coopera_contact': string = undefined;
  @ApiProperty({ description: '合作单位手机号' })
  @Rule(RuleType['string']().empty(''))
  'coopera_phone': string = undefined;
  @ApiProperty({ description: '项目背景' })
  @Rule(RuleType['string']().empty(''))
  'project_back': string = undefined;
  @ApiProperty({ description: '立项意义' })
  @Rule(RuleType['string']().empty(''))
  'sign': string = undefined;
  @ApiProperty({ description: '前期基础' })
  @Rule(RuleType['string']().empty(''))
  'work_basics': string = undefined;
  @ApiProperty({ description: '研究内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '技术路线' })
  @Rule(RuleType['string']().empty(''))
  'route': string = undefined;
  @ApiProperty({ description: '核心指标' })
  @Rule(RuleType['string']().empty(''))
  'quota': string = undefined;
  @ApiProperty({ description: '经济效益' })
  @Rule(RuleType['string']().empty(''))
  'influence': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_projectInfo extends FVO_projectInfo {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_projectInfo extends CDTO_projectInfo {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_projectInfo extends FVO_projectInfo {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
