import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_projectNotice {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '年度' })
  'year': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '来源' })
  'origin': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'create_date': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '图片文件' })
  'img_url': Array<any> = undefined;
  @ApiProperty({ description: '附件文件' })
  'file_url': Array<any> = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_projectNotice extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['year', 'title', 'origin', 'create_date', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '年度' })
  'year': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '来源' })
  'origin': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'create_date': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_projectNotice extends FVO_projectNotice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_projectNotice {
  @ApiProperty({ description: '年度' })
  @Rule(RuleType['string']().empty(''))
  'year': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '来源' })
  @Rule(RuleType['string']().empty(''))
  'origin': string = undefined;
  @ApiProperty({ description: '发布时间' })
  @Rule(RuleType['string']().empty(''))
  'create_date': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '图片文件' })
  @Rule(RuleType['array']().empty(''))
  'img_url': Array<any> = undefined;
  @ApiProperty({ description: '附件文件' })
  @Rule(RuleType['array']().empty(''))
  'file_url': Array<any> = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_projectNotice extends FVO_projectNotice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_projectNotice extends CDTO_projectNotice {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_projectNotice extends FVO_projectNotice {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
