import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_subscribeOrder {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '服务类型' })
  'type': string = undefined;
  @ApiProperty({ description: '机构' })
  'organ_id': string = undefined;
  @ApiProperty({ description: '服务名称' })
  'project': object = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '服务时间' })
  'service_date': string = undefined;
  @ApiProperty({ description: '预约备注' })
  'remerk': string = undefined;
  @ApiProperty({ description: '是否开发票' })
  'is_money': string = undefined;
  @ApiProperty({ description: '单位名称' })
  'company': string = undefined;
  @ApiProperty({ description: '机构代码' })
  'company_code': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_subscribeOrder extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'type',
      'organ_id',
      'project',
      'contact',
      'phone',
      'email',
      'service_date',
      'is_money',
      'company',
      'company_code',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '服务类型' })
  'type': string = undefined;
  @ApiProperty({ description: '机构' })
  'organ_id': string = undefined;
  @ApiProperty({ description: '服务名称' })
  'project': object = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '服务时间' })
  'service_date': string = undefined;
  @ApiProperty({ description: '是否开发票' })
  'is_money': string = undefined;
  @ApiProperty({ description: '单位名称' })
  'company': string = undefined;
  @ApiProperty({ description: '机构代码' })
  'company_code': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_subscribeOrder extends FVO_subscribeOrder {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_subscribeOrder {
  @ApiProperty({ description: '服务类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '机构' })
  @Rule(RuleType['string']().empty(''))
  'organ_id': string = undefined;
  @ApiProperty({ description: '服务名称' })
  @Rule(RuleType['object']().empty(''))
  'project': object = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '服务时间' })
  @Rule(RuleType['string']().empty(''))
  'service_date': string = undefined;
  @ApiProperty({ description: '预约备注' })
  @Rule(RuleType['string']().empty(''))
  'remerk': string = undefined;
  @ApiProperty({ description: '是否开发票' })
  @Rule(RuleType['string']().empty(''))
  'is_money': string = undefined;
  @ApiProperty({ description: '单位名称' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '机构代码' })
  @Rule(RuleType['string']().empty(''))
  'company_code': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_subscribeOrder extends FVO_subscribeOrder {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_subscribeOrder extends CDTO_subscribeOrder {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_subscribeOrder extends FVO_subscribeOrder {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
