import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_subscribeOrgan {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '联系地址' })
  'address': string = undefined;
  @ApiProperty({ description: '所属' })
  'belong': string = undefined;
  @ApiProperty({ description: '资质' })
  'natural': string = undefined;
  @ApiProperty({ description: '成果' })
  'achieve': string = undefined;
  @ApiProperty({ description: '条件' })
  'condition': string = undefined;
  @ApiProperty({ description: '团队' })
  'team': string = undefined;
  @ApiProperty({ description: '图片' })
  'image_file': Array<any> = undefined;
  @ApiProperty({ description: '服务项目' })
  'project': Array<any> = undefined;
  @ApiProperty({ description: '设备共享' })
  'equipment': Array<any> = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_subscribeOrgan extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'contact', 'phone', 'address', 'belong', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '联系地址' })
  'address': string = undefined;
  @ApiProperty({ description: '所属' })
  'belong': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_subscribeOrgan extends FVO_subscribeOrgan {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_subscribeOrgan {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '联系地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '所属' })
  @Rule(RuleType['string']().empty(''))
  'belong': string = undefined;
  @ApiProperty({ description: '资质' })
  @Rule(RuleType['string']().empty(''))
  'natural': string = undefined;
  @ApiProperty({ description: '成果' })
  @Rule(RuleType['string']().empty(''))
  'achieve': string = undefined;
  @ApiProperty({ description: '条件' })
  @Rule(RuleType['string']().empty(''))
  'condition': string = undefined;
  @ApiProperty({ description: '团队' })
  @Rule(RuleType['string']().empty(''))
  'team': string = undefined;
  @ApiProperty({ description: '图片' })
  @Rule(RuleType['array']().empty(''))
  'image_file': Array<any> = undefined;
  @ApiProperty({ description: '服务项目' })
  @Rule(RuleType['array']().empty(''))
  'project': Array<any> = undefined;
  @ApiProperty({ description: '设备共享' })
  @Rule(RuleType['array']().empty(''))
  'equipment': Array<any> = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_subscribeOrgan extends FVO_subscribeOrgan {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_subscribeOrgan extends CDTO_subscribeOrgan {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_subscribeOrgan extends FVO_subscribeOrgan {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
