import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_menus {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '菜单名称' })
  'name': string = undefined;
  @ApiProperty({ description: '模块id' })
  'module_id': string = undefined;
  @ApiProperty({ description: '父级菜单' })
  'parent_id': string = undefined;
  @ApiProperty({ description: '路由地址' })
  'path': string = undefined;
  @ApiProperty({ description: '组件地址' })
  'component': string = undefined;
  @ApiProperty({ description: '菜单类型' })
  'type': string = undefined;
  @ApiProperty({ description: '图标' })
  'icon': string = undefined;
  @ApiProperty({ description: '设置' })
  'config': object = undefined;
  @ApiProperty({ description: '显示顺序' })
  'sort': number = undefined;
  @ApiProperty({ description: '备注' })
  'remark': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}
export class QueryVO_menus extends FVO_menus {}
export class QDTO_menus extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'name',
      'module_id',
      'parent_id',
      'path',
      'component',
      'type',
      'icon',
      'sort',
      'is_use',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '菜单名称' })
  'name': string = undefined;
  @ApiProperty({ description: '模块id' })
  'module_id': string = undefined;
  @ApiProperty({ description: '父级菜单' })
  'parent_id': string = undefined;
  @ApiProperty({ description: '路由地址' })
  'path': string = undefined;
  @ApiProperty({ description: '组件地址' })
  'component': string = undefined;
  @ApiProperty({ description: '菜单类型' })
  'type': string = undefined;
  @ApiProperty({ description: '图标' })
  'icon': string = undefined;
  @ApiProperty({ description: '显示顺序' })
  'sort': number = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_menus extends FVO_menus {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_menus {
  @ApiProperty({ description: '菜单名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '模块id' })
  @Rule(RuleType['string']().empty(''))
  'module_id': string = undefined;
  @ApiProperty({ description: '父级菜单' })
  @Rule(RuleType['string']().empty(''))
  'parent_id': string = undefined;
  @ApiProperty({ description: '路由地址' })
  @Rule(RuleType['string']().empty(''))
  'path': string = undefined;
  @ApiProperty({ description: '组件地址' })
  @Rule(RuleType['string']().empty(''))
  'component': string = undefined;
  @ApiProperty({ description: '菜单类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '图标' })
  @Rule(RuleType['string']().empty(''))
  'icon': string = undefined;
  @ApiProperty({ description: '设置' })
  @Rule(RuleType['object']().empty(''))
  'config': object = undefined;
  @ApiProperty({ description: '显示顺序' })
  @Rule(RuleType['number']().empty(''))
  'sort': number = undefined;
  @ApiProperty({ description: '备注' })
  @Rule(RuleType['string']().empty(''))
  'remark': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_menus extends FVO_menus {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_menus extends CDTO_menus {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_menus extends FVO_menus {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
