import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_module {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '模块名称' })
  'name': string = undefined;
  @ApiProperty({ description: '模块地址' })
  'url': string = undefined;
  @ApiProperty({ description: '模块简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_module extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '模块名称' })
  'name': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_module extends FVO_module {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_module {
  @ApiProperty({ description: '模块名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '模块地址' })
  @Rule(RuleType['string']().empty(''))
  'url': string = undefined;
  @ApiProperty({ description: '模块简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_module extends FVO_module {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_module extends CDTO_module {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_module extends FVO_module {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
