import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockChat {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人' })
  'sender_name': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_time': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_dockChat extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'dock_id',
      'sender_id',
      'sender_name',
      'send_time',
      'is_use',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人' })
  'sender_name': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'send_time': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_dockChat extends FVO_dockChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dockChat {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  @Rule(RuleType['string']().empty(''))
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人' })
  @Rule(RuleType['string']().empty(''))
  'sender_name': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '发送时间' })
  @Rule(RuleType['string']().empty(''))
  'send_time': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_dockChat extends FVO_dockChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockChat extends CDTO_dockChat {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockChat extends FVO_dockChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
