import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockExpert {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '关联专家id' })
  'expert_id': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '最高学历' })
  'education': string = undefined;
  @ApiProperty({ description: '所在院校' })
  'school': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_dockExpert extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'dock_id',
      'expert_id',
      'name',
      'icon',
      'education',
      'school',
      'is_use',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '关联专家id' })
  'expert_id': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '头像' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '最高学历' })
  'education': string = undefined;
  @ApiProperty({ description: '所在院校' })
  'school': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_dockExpert extends FVO_dockExpert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dockExpert {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '关联专家id' })
  @Rule(RuleType['string']().empty(''))
  'expert_id': string = undefined;
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '最高学历' })
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '所在院校' })
  @Rule(RuleType['string']().empty(''))
  'school': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_dockExpert extends FVO_dockExpert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockExpert extends CDTO_dockExpert {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockExpert extends FVO_dockExpert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
