import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockImgtxt {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '发送人' })
  'user_id': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '图片文件' })
  'img_file': Array<any> = undefined;
  @ApiProperty({ description: '视频文件' })
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'create_time': string = undefined;
}

export class QDTO_dockImgtxt extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['dock_id', 'user_id', 'content', 'is_use', 'create_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '发送人' })
  'user_id': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
  @ApiProperty({ description: '发送时间' })
  'create_time': string = undefined;
}

export class QVO_dockImgtxt extends FVO_dockImgtxt {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dockImgtxt {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '发送人' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '图片文件' })
  @Rule(RuleType['array']().empty(''))
  'img_file': Array<any> = undefined;
  @ApiProperty({ description: '视频文件' })
  @Rule(RuleType['array']().empty(''))
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
  @ApiProperty({ description: '发送时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
}

export class CVO_dockImgtxt extends FVO_dockImgtxt {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockImgtxt extends CDTO_dockImgtxt {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockImgtxt extends FVO_dockImgtxt {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
