import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockJbft {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '关联展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'create_date': string = undefined;
  @ApiProperty({ description: '信息来源' })
  'origin': string = undefined;
  @ApiProperty({ description: '信息简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '图片文件' })
  'image_file': Array<any> = undefined;
  @ApiProperty({ description: '视频文件' })
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_dockJbft extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['dock_id', 'title', 'create_date', 'origin', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '关联展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '发布时间' })
  'create_date': string = undefined;
  @ApiProperty({ description: '信息来源' })
  'origin': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_dockJbft extends FVO_dockJbft {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dockJbft {
  @ApiProperty({ description: '关联展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '发布时间' })
  @Rule(RuleType['string']().empty(''))
  'create_date': string = undefined;
  @ApiProperty({ description: '信息来源' })
  @Rule(RuleType['string']().empty(''))
  'origin': string = undefined;
  @ApiProperty({ description: '信息简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '图片文件' })
  @Rule(RuleType['array']().empty(''))
  'image_file': Array<any> = undefined;
  @ApiProperty({ description: '视频文件' })
  @Rule(RuleType['array']().empty(''))
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_dockJbft extends FVO_dockJbft {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockJbft extends CDTO_dockJbft {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockJbft extends FVO_dockJbft {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
