import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockTrans {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '产品id' })
  'product_id': string = undefined;
  @ApiProperty({ description: '产品名称' })
  'product_name': string = undefined;
  @ApiProperty({ description: '供给者id' })
  's_id': string = undefined;
  @ApiProperty({ description: '供给者姓名' })
  's_name': string = undefined;
  @ApiProperty({ description: '供给者手机号' })
  's_phone': string = undefined;
  @ApiProperty({ description: '需求者id' })
  'd_id': string = undefined;
  @ApiProperty({ description: '需求者姓名' })
  'd_name': string = undefined;
  @ApiProperty({ description: '需求者手机号' })
  'd_phone': string = undefined;
  @ApiProperty({ description: '合同备份' })
  'contract': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '创建时间' })
  'create_time': string = undefined;
}

export class QDTO_dockTrans extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'dock_id',
      'product_id',
      'product_name',
      's_id',
      's_name',
      's_phone',
      'd_id',
      'd_name',
      'd_phone',
      'status',
      'create_time',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '产品id' })
  'product_id': string = undefined;
  @ApiProperty({ description: '产品名称' })
  'product_name': string = undefined;
  @ApiProperty({ description: '供给者id' })
  's_id': string = undefined;
  @ApiProperty({ description: '供给者姓名' })
  's_name': string = undefined;
  @ApiProperty({ description: '供给者手机号' })
  's_phone': string = undefined;
  @ApiProperty({ description: '需求者id' })
  'd_id': string = undefined;
  @ApiProperty({ description: '需求者姓名' })
  'd_name': string = undefined;
  @ApiProperty({ description: '需求者手机号' })
  'd_phone': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '创建时间' })
  'create_time': string = undefined;
}

export class QVO_dockTrans extends FVO_dockTrans {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dockTrans {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '产品id' })
  @Rule(RuleType['string']().empty(''))
  'product_id': string = undefined;
  @ApiProperty({ description: '产品名称' })
  @Rule(RuleType['string']().empty(''))
  'product_name': string = undefined;
  @ApiProperty({ description: '供给者id' })
  @Rule(RuleType['string']().empty(''))
  's_id': string = undefined;
  @ApiProperty({ description: '供给者姓名' })
  @Rule(RuleType['string']().empty(''))
  's_name': string = undefined;
  @ApiProperty({ description: '供给者手机号' })
  @Rule(RuleType['string']().empty(''))
  's_phone': string = undefined;
  @ApiProperty({ description: '需求者id' })
  @Rule(RuleType['string']().empty(''))
  'd_id': string = undefined;
  @ApiProperty({ description: '需求者姓名' })
  @Rule(RuleType['string']().empty(''))
  'd_name': string = undefined;
  @ApiProperty({ description: '需求者手机号' })
  @Rule(RuleType['string']().empty(''))
  'd_phone': string = undefined;
  @ApiProperty({ description: '合同备份' })
  @Rule(RuleType['array']().empty(''))
  'contract': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '创建时间' })
  @Rule(RuleType['string']().empty(''))
  'create_time': string = undefined;
}

export class CVO_dockTrans extends FVO_dockTrans {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockTrans extends CDTO_dockTrans {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockTrans extends FVO_dockTrans {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
