import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockUser {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '申请人id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '手机' })
  'phone': string = undefined;
  @ApiProperty({ description: '申请时间' })
  'apply_date': string = undefined;
  @ApiProperty({ description: '参展项目' })
  'productList': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_dockUser extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'dock_id',
      'user_id',
      'name',
      'phone',
      'apply_date',
      'status',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '申请人id' })
  'user_id': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '手机' })
  'phone': string = undefined;
  @ApiProperty({ description: '申请时间' })
  'apply_date': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QVO_dockUser extends FVO_dockUser {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
export class CDTO_userCheck {
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '商品id' })
  @Rule(RuleType['string']().empty(''))
  'good_id': string = undefined;
}
export class CDTO_dockUser {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '申请人id' })
  @Rule(RuleType['string']().empty(''))
  'user_id': string = undefined;
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '手机' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '申请时间' })
  @Rule(RuleType['string']().empty(''))
  'apply_date': string = undefined;
  @ApiProperty({ description: '参展项目' })
  @Rule(RuleType['array']().empty(''))
  'productList': Array<any> = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_dockUser extends FVO_dockUser {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockUser extends CDTO_dockUser {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockUser extends FVO_dockUser {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
