import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_dockVideo {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '视频文件' })
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '排序' })
  'sort': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QDTO_dockVideo extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['dock_id', 'title', 'sort', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'dock_id': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '排序' })
  'sort': string = undefined;
  @ApiProperty({ description: '是否启用' })
  'is_use': string = undefined;
}

export class QVO_dockVideo extends FVO_dockVideo {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_dockVideo {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'dock_id': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '视频文件' })
  @Rule(RuleType['array']().empty(''))
  'video_file': Array<any> = undefined;
  @ApiProperty({ description: '排序' })
  @Rule(RuleType['string']().empty(''))
  'sort': string = undefined;
  @ApiProperty({ description: '是否启用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_dockVideo extends FVO_dockVideo {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_dockVideo extends CDTO_dockVideo {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_dockVideo extends FVO_dockVideo {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
