import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_train {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '房间号' })
  'room_id': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '省份' })
  'province': string = undefined;
  @ApiProperty({ description: '市区' })
  'city': string = undefined;
  @ApiProperty({ description: '负责人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '主办方' })
  'sponsor': string = undefined;
  @ApiProperty({ description: '承办方' })
  'organizer': string = undefined;
  @ApiProperty({ description: '信息简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class QDTO_train extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'room_id',
      'type',
      'password',
      'title',
      'start_time',
      'end_time',
      'province',
      'city',
      'contact',
      'phone',
      'status',
      'role',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '房间号' })
  'room_id': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '省份' })
  'province': string = undefined;
  @ApiProperty({ description: '市区' })
  'city': string = undefined;
  @ApiProperty({ description: '负责人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class QVO_train extends FVO_train {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_train {
  @ApiProperty({ description: '房间号' })
  @Rule(RuleType['string']().empty(''))
  'room_id': string = undefined;
  @ApiProperty({ description: '用户类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '标题' })
  @Rule(RuleType['string']().empty(''))
  'title': string = undefined;
  @ApiProperty({ description: '开始时间' })
  @Rule(RuleType['string']().empty(''))
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  @Rule(RuleType['string']().empty(''))
  'end_time': string = undefined;
  @ApiProperty({ description: '省份' })
  @Rule(RuleType['string']().empty(''))
  'province': string = undefined;
  @ApiProperty({ description: '市区' })
  @Rule(RuleType['string']().empty(''))
  'city': string = undefined;
  @ApiProperty({ description: '负责人' })
  @Rule(RuleType['string']().empty(''))
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '主办方' })
  @Rule(RuleType['string']().empty(''))
  'sponsor': string = undefined;
  @ApiProperty({ description: '承办方' })
  @Rule(RuleType['string']().empty(''))
  'organizer': string = undefined;
  @ApiProperty({ description: '信息简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
}

export class CVO_train extends FVO_train {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_train extends CDTO_train {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_train extends FVO_train {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '房间号' })
  'room_id': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '标题' })
  'title': string = undefined;
  @ApiProperty({ description: '开始时间' })
  'start_time': string = undefined;
  @ApiProperty({ description: '结束时间' })
  'end_time': string = undefined;
  @ApiProperty({ description: '省份' })
  'province': string = undefined;
  @ApiProperty({ description: '市区' })
  'city': string = undefined;
  @ApiProperty({ description: '负责人' })
  'contact': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '主办方' })
  'sponsor': string = undefined;
  @ApiProperty({ description: '承办方' })
  'organizer': string = undefined;
  @ApiProperty({ description: '信息简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class LoginDTO {
  @ApiProperty({ description: '房间号', example: '3001' })
  @Rule(RuleType['string']().empty(''))
  'room_id': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
