import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_trainChat {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '展会id' })
  'train_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人姓名' })
  'sender_name': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '时间' })
  'send_time': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_trainChat extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['train_id', 'sender_id', 'sender_name', 'send_time'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '展会id' })
  'train_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人姓名' })
  'sender_name': string = undefined;
  @ApiProperty({ description: '时间' })
  'send_time': string = undefined;
}

export class QVO_trainChat extends FVO_trainChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_trainChat {
  @ApiProperty({ description: '展会id' })
  @Rule(RuleType['string']().empty(''))
  'train_id': string = undefined;
  @ApiProperty({ description: '发送人id' })
  @Rule(RuleType['string']().empty(''))
  'sender_id': string = undefined;
  @ApiProperty({ description: '发送人姓名' })
  @Rule(RuleType['string']().empty(''))
  'sender_name': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '时间' })
  @Rule(RuleType['string']().empty(''))
  'send_time': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_trainChat extends FVO_trainChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_trainChat extends CDTO_trainChat {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_trainChat extends FVO_trainChat {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
