import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_admin {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '所属上级' })
  'pid': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '机构名称' })
  'dept_name': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class QDTO_admin extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'pid',
      'type',
      'code',
      'account',
      'name',
      'phone',
      'dept_name',
      'role',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '所属上级' })
  'pid': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '机构名称' })
  'dept_name': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class QVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_admin {
  @ApiProperty({ description: '所属上级' })
  @Rule(RuleType['string']().empty(''))
  'pid': string = undefined;
  @ApiProperty({ description: '用户类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '机构名称' })
  @Rule(RuleType['string']().empty(''))
  'dept_name': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
}

export class CVO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_admin extends CDTO_admin {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_admin extends FVO_admin {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = get(data, key);
    }
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '所属上级' })
  'pid': string = undefined;
  @ApiProperty({ description: '用户类型' })
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '机构名称' })
  'dept_name': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '用户id', example: '' })
  @Rule(RuleType['string']().required())
  'id': string = undefined;
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
