import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_expert {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号类型' })
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  'password': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '联系地址' })
  'address': string = undefined;
  @ApiProperty({ description: '办公电话' })
  'work_phone': string = undefined;
  @ApiProperty({ description: '所属行业' })
  'industry': string = undefined;
  @ApiProperty({ description: '所属辖区' })
  'area': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '出生日期' })
  'birth': string = undefined;
  @ApiProperty({ description: 'qq&&微信' })
  'qqwx': string = undefined;
  @ApiProperty({ description: '所在院校' })
  'school': string = undefined;
  @ApiProperty({ description: '最高学历' })
  'education': string = undefined;
  @ApiProperty({ description: '所学专业' })
  'major': string = undefined;
  @ApiProperty({ description: '单位名称' })
  'company': string = undefined;
  @ApiProperty({ description: '职务职称' })
  'zwzc': string = undefined;
  @ApiProperty({ description: '头像图片' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '擅长领域' })
  'expertise': string = undefined;
  @ApiProperty({ description: '工作经历' })
  'workexperience': string = undefined;
  @ApiProperty({ description: '科研综述' })
  'scientific': string = undefined;
  @ApiProperty({ description: '承担项目' })
  'undertakingproject': string = undefined;
  @ApiProperty({ description: '科技奖励' })
  'scienceaward': string = undefined;
  @ApiProperty({ description: '社会任职' })
  'social': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '个人用户id' })
  'personal_id': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class QDTO_expert extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [
      'type',
      'code',
      'account',
      'name',
      'phone',
      'email',
      'card',
      'status',
      'personal_id',
      'role',
    ];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '账号类型' })
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '个人用户id' })
  'personal_id': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
  @ApiProperty({ description: '是否处理' })
  'is_filter': string = undefined;
}

export class QVO_expert extends FVO_expert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_expert {
  @ApiProperty({ description: '账号类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  @Rule(RuleType['string']().empty(''))
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '联系地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '办公电话' })
  @Rule(RuleType['string']().empty(''))
  'work_phone': string = undefined;
  @ApiProperty({ description: '所属行业' })
  @Rule(RuleType['string']().empty(''))
  'industry': string = undefined;
  @ApiProperty({ description: '所属辖区' })
  @Rule(RuleType['string']().empty(''))
  'area': string = undefined;
  @ApiProperty({ description: '身份证号' })
  @Rule(RuleType['string']().empty(''))
  'card': string = undefined;
  @ApiProperty({ description: '出生日期' })
  @Rule(RuleType['string']().empty(''))
  'birth': string = undefined;
  @ApiProperty({ description: 'qq&&微信' })
  @Rule(RuleType['string']().empty(''))
  'qqwx': string = undefined;
  @ApiProperty({ description: '所在院校' })
  @Rule(RuleType['string']().empty(''))
  'school': string = undefined;
  @ApiProperty({ description: '最高学历' })
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '所学专业' })
  @Rule(RuleType['string']().empty(''))
  'major': string = undefined;
  @ApiProperty({ description: '单位名称' })
  @Rule(RuleType['string']().empty(''))
  'company': string = undefined;
  @ApiProperty({ description: '职务职称' })
  @Rule(RuleType['string']().empty(''))
  'zwzc': string = undefined;
  @ApiProperty({ description: '头像图片' })
  @Rule(RuleType['array']().empty(''))
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '擅长领域' })
  @Rule(RuleType['string']().empty(''))
  'expertise': string = undefined;
  @ApiProperty({ description: '工作经历' })
  @Rule(RuleType['string']().empty(''))
  'workexperience': string = undefined;
  @ApiProperty({ description: '科研综述' })
  @Rule(RuleType['string']().empty(''))
  'scientific': string = undefined;
  @ApiProperty({ description: '承担项目' })
  @Rule(RuleType['string']().empty(''))
  'undertakingproject': string = undefined;
  @ApiProperty({ description: '科技奖励' })
  @Rule(RuleType['string']().empty(''))
  'scienceaward': string = undefined;
  @ApiProperty({ description: '社会任职' })
  @Rule(RuleType['string']().empty(''))
  'social': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '个人用户id' })
  @Rule(RuleType['string']().empty(''))
  'personal_id': string = undefined;
  @ApiProperty({ description: '角色' })
  @Rule(RuleType['array']().empty(''))
  'role': Array<any> = undefined;
}

export class CVO_expert extends FVO_expert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_expert extends CDTO_expert {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_expert extends FVO_expert {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
export class LoginVO {
  constructor(data: object) {
    for (const key of Object.keys(this)) {
      this[key] = get(data, key);
    }
    this.type = '6';
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '账号类型' })
  'type': string = undefined;
  @ApiProperty({ description: '邀请码' })
  'code': string = undefined;
  @ApiProperty({ description: '账号' })
  'account': string = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '手机号' })
  'phone': string = undefined;
  @ApiProperty({ description: '电子邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '联系地址' })
  'address': string = undefined;
  @ApiProperty({ description: '办公电话' })
  'work_phone': string = undefined;
  @ApiProperty({ description: '所属行业' })
  'industry': string = undefined;
  @ApiProperty({ description: '所属辖区' })
  'area': string = undefined;
  @ApiProperty({ description: '身份证号' })
  'card': string = undefined;
  @ApiProperty({ description: '出生日期' })
  'birth': string = undefined;
  @ApiProperty({ description: 'qq&&微信' })
  'qqwx': string = undefined;
  @ApiProperty({ description: '所在院校' })
  'school': string = undefined;
  @ApiProperty({ description: '最高学历' })
  'education': string = undefined;
  @ApiProperty({ description: '所学专业' })
  'major': string = undefined;
  @ApiProperty({ description: '单位名称' })
  'company': string = undefined;
  @ApiProperty({ description: '职务职称' })
  'zwzc': string = undefined;
  @ApiProperty({ description: '头像图片' })
  'icon': Array<any> = undefined;
  @ApiProperty({ description: '擅长领域' })
  'expertise': string = undefined;
  @ApiProperty({ description: '工作经历' })
  'workexperience': string = undefined;
  @ApiProperty({ description: '科研综述' })
  'scientific': string = undefined;
  @ApiProperty({ description: '承担项目' })
  'undertakingproject': string = undefined;
  @ApiProperty({ description: '科技奖励' })
  'scienceaward': string = undefined;
  @ApiProperty({ description: '社会任职' })
  'social': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '个人用户id' })
  'personal_id': string = undefined;
  @ApiProperty({ description: '角色' })
  'role': Array<any> = undefined;
}

export class LoginDTO {
  @ApiProperty({ description: '账号', example: 'test' })
  @Rule(RuleType['string']().empty(''))
  'account': string = undefined;
  @ApiProperty({ description: '密码', example: '111111' })
  @Rule(RuleType['string']().empty(''))
  'password': string = undefined;
}

export class ResetPasswordDTO {
  @ApiProperty({ description: '密码', example: '123456' })
  @Rule(RuleType['string']().required())
  'password': string = undefined;
}
