import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { PersonChat } from '../../entity/product/personChat.entity';
import { PersonRoom } from '../../entity/product/personRoom.entity';
type modelType = ReturnModelType<typeof PersonChat>;
@Provide()
export class PersonChatService extends BaseService<modelType> {
  @InjectEntityModel(PersonChat)
  model: modelType;

  @InjectEntityModel(PersonRoom)
  roomModel: ReturnModelType<typeof PersonRoom>;

  /** 修改房间信息 */
  async afterCreate(data) {
    const body = {
      p1_id: data.sender_id,
      p1_name: data.sender_name,
      p2_id: data.receiver_id,
      p2_name: data.receiver_name,
      last_time: data.send_time,
    };
    await this.roomModel.updateOne({ _id: data.room_id }, body);
  }
}
