import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { PersonRoom } from '../../entity/product/personRoom.entity';
type modelType = ReturnModelType<typeof PersonRoom>;
@Provide()
export class PersonRoomService extends BaseService<modelType> {
  @InjectEntityModel(PersonRoom)
  model: modelType;

  async beforeQuery(query) {
    const { skip = 0, limit = 0, ...info } = query;
    if (this.ctx.user) {
      info.$or = [{ p1_id: this.ctx.user._id }, { p2_id: this.ctx.user._id }];
    }
    const data = await this.model.find(info).skip(skip).limit(limit);
    const total = await this.model.count(info);
    return { data, total };
  }
}
