import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { DockTrans } from '../../entity/technology/dockTrans.entity';
type modelType = ReturnModelType<typeof DockTrans>;
@Provide()
export class DockTransService extends BaseService<modelType> {
  @InjectEntityModel(DockTrans)
  model: modelType;

  async beforeQuery(query) {
    const { skip = 0, limit = 0, ...info } = query;
    if (this.ctx.user) {
      if (
        this.ctx.user.type === '4' ||
        this.ctx.user.type === '5' ||
        this.ctx.user.type === '6'
      ) {
        info.$or = [{ s_id: this.ctx.user._id }, { d_id: this.ctx.user._id }];
      }
    }
    const data = await this.model.find(info).skip(skip).limit(limit);
    const total = await this.model.count(info);
    return { data, total };
  }
}
